
public class StackBuilderTester {

    /**
     * Add elements 0, 1, ..., size - 1 to list (in order).
     */
    public static void buildStack(SimpleStack<Integer> stk, int size) {
	for (int i = 0; i < size; ++i) {
	    stk.push(i);
	}
    }

    static int[] getSizeArray(int max, int step) {
	int[] sizes = new int[max / step];
	int size = step;

	for (int i = 0; i < max / step; ++i) {
	    sizes[i] = step + i * step;
	}

	return sizes;
    }


    public static void main(String[] args) {
	int[] sizes = getSizeArray(10_000, 100);
	RunTimer rt = new RunTimer();
	CSVWriter csv = new CSVWriter("list-buildtime.csv");

	csv.addEntry("list size");
	csv.addEntry("ArraySimpleStackOne time (ns)");
	csv.addEntry("ArraySimpleStackTwo time (ns)");
	csv.endLine();

	SimpleStack<Integer> one;
	SimpleStack<Integer> two;

	for (int size : sizes) {
	    one = new ArraySimpleStackOne<Integer>();
	    two = new ArraySimpleStackTwo<Integer>();

	    csv.addEntry(size);

	    rt.reset();
	    rt.start();
	    buildStack(one, size);
	    rt.stop();
	    csv.addEntry(rt.getElapsedNanos());

	    rt.reset();
	    rt.start();
	    buildStack(two, size);
	    rt.stop();
	    csv.addEntry(rt.getElapsedNanos());
	    
	    csv.endLine();
	}

	csv.close();
    }


}
